package sample;

import java.util.ArrayList;

import rescuecore2.log.Logger;
import rescuecore2.worldmodel.EntityID;
import sample.efpo.EFPO;

public class CentralAssignmentEFPO implements CentralAssignment 
{	
    private ArrayList<EntityID> agents;
    private ArrayList<Object> targets;
    private boolean DEBUG = false;

    public void init(ArrayList<EntityID> agents, ArrayList<Object> targets) {
	this.agents = agents;
	this.targets = targets;
	DEBUG = true;
    }

    // Compute the assignment
    public double[][] compute(double [][] U)
    {
	if (U.length == 0  || U[0].length == 0) {
	    Logger.errC("ERROR: Cannot compute Matrix. Input is zero!");
	    return null;
	}
	if (DEBUG) {
	    System.out.println("Utility Matrix: ");
	    for (int i=0; i<agents.size(); i++) {
		for (int j=0; j<targets.size(); j++) {
		    System.out.format("%1.2f ",U[i][j]);
		}
		System.out.println();
	    }
	    System.out.println();
	}

	EFPO efpo = new EFPO(U);
	double[][] A = efpo.getAlloc(false);
	return A;
    }
}
