package sample;

import java.util.ArrayList;

import rescuecore2.worldmodel.EntityID;
import sample.com.BaseMessage;


public interface DecentralAssignment {
	/*
	 * Initializes the agent. Should be called before each negotiation process
	 * starts. Computes for example the initial target assignment.
	 */
	public void init(double [][] U, ArrayList<EntityID> agents, ArrayList<EntityID> targets, EntityID identity);

	/*
	 * Send a message to all neighbors.
	 */
	public BaseMessage sendMessage();

	
	/*
	 * Receives messages from all neighbors
	 */
	public void receiveMessages(ArrayList<BaseMessage> msgs);

	/*
	 * Computes the assignment decision and returns true when 
	 * the termination criterion is met.
	 */
	public boolean compute();
	
	/*
	 * Returns the selected target. Should only be called
	 * after termination.
	 */	
	public EntityID getSelectedTarget();	

	/*
	 * Returns the identity of the  target.
	 */	
	public EntityID getIdentity();	

}